//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <boost/bind.hpp>
#include <boost/cast.hpp>
#include <babel.h>
#include "Win32Common.h"
#include "Exceptions.h"
#include "DevasApp.h"
using namespace std;
using namespace boost;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TDevasApp::TDevasApp(): option_(new TOption), backup_(new TBackup)
{
}

//---------------------------------------------------------------------------
TSearchResult TDevasApp::Search(const TStringVector& paths,
    const TStringVector& ssFilter, const std::string& sSearched)
  //pathsssFilter𖞂t@CsSearched
{
  try{
    //t@CQ̍쐬
    setFile_.reset(new TFileSet(backup_.get()));
    setFile_->SetOnReportProcess(onReportProcess_);
    setFile_->SetOnFileError(onFileError_);
    setFile_->SetCharCode(option_->CharCode());
    setFile_->SetCheckCharCode(option_->CheckCharCode());
    setFile_->SetCheckTime(option_->CheckTime());
    setFile_->SetMaxFileSize(option_->MaxFileSize());
    if (!paths.empty() && GetPathKind(paths[0])==pkDir){
      setFile_->SetDir(paths[0], ssFilter, option_->SubDir());
    }else{
      setFile_->SetFiles(paths);
    }
    if (!setFile_->TargetExists()) return srNoFiles;
    //ʒuXg̍쐬
    if (setFile_->MultiByte())
      listPlace_.reset(new TPlaceList<wchar_t>);
    else
      listPlace_.reset(new TPlaceList<char>);
    listPlace_->SetOnPlaceAdd(bind(&TDevasApp::OnPlaceAdd, this, _1));
    //p^[̍쐬
    auto_ptr<TAbstractSearchedPattern> pattern;
    TSearchInfo info;
    info.bMultiByte_= setFile_->MultiByte();
    info.sSearched_= sSearched;
    info.mode_= option_->Mode();
    info.bCaseSensitive_= option_->CaseSensitive();
    info.bEscape_= option_->Escape();
    info.bByLine_= option_->ByLine();
    info.bRecordLine_= option_->ShowLine();
    try{
      pattern.reset(TAbstractSearchedPattern::NewSearchedPattern(info));
    }catch (EInvalidSearchedPattern&){
      return srInvalid;//sȌp^[
    }
    //
    return setFile_->Search(pattern.get(), listPlace_.get());
  }catch (EStoppedException&){
    return srStopped;
  }
}

//---------------------------------------------------------------------------
TReplaceResult TDevasApp::Replace(const std::string& sReplacing)
  //sReplacingŒu
{
  try{
    assert(setFile_.get() && listPlace_.get());
    auto_ptr<TAbstractReplacingPattern> pattern(
      NewReplacingPattern(sReplacing));
    return setFile_->Replace(pattern.get(), listPlace_.get(),
      option_->Backup());
  }catch (EStoppedException&){
    return rrStopped;
  }
}

//---------------------------------------------------------------------------
std::string TDevasApp::ReplacingStr(int nPlace, const std::string& sReplacing)
  //ẅʒusReplacingŒu
{
	assert(listPlace_.get() && nPlace<listPlace_->PlaceCount());
  auto_ptr<TAbstractReplacingPattern> pattern(
  	NewReplacingPattern(sReplacing));
  babel::init_babel();
  if (setFile_->MultiByte()){
  	TReplacingPattern<wchar_t>* pattern2=
    	polymorphic_downcast<TReplacingPattern<wchar_t>*>(pattern.get());
		return babel::unicode_to_sjis(pattern2->ReplacingTstr(
    	polymorphic_downcast<TPlaceList<wchar_t>*>(listPlace_.get()), nPlace));
  }else{
  	TReplacingPattern<char>* pattern2=
    	polymorphic_downcast<TReplacingPattern<char>*>(pattern.get());
		return pattern2->ReplacingTstr(
    	polymorphic_downcast<TPlaceList<char>*>(listPlace_.get()),
      nPlace);
  }
}

//---------------------------------------------------------------------------
void TDevasApp::OnPlaceAdd(TAbstractPlace* place)//ʒuǉꂽ
{
	if (!onPlaceAdd_.empty()) onPlaceAdd_(place);
}

//---------------------------------------------------------------------------
TAbstractReplacingPattern* TDevasApp::NewReplacingPattern
    (const std::string& sReplacing)
  //w̒u̒up^[
{
  TReplaceInfo info;
  info.bMultiByte_= setFile_->MultiByte();
  info.sReplacing_= sReplacing;
  info.mode_= option_->Mode();
  info.bEscape_= option_->Escape();
  return TAbstractReplacingPattern::NewReplacingPattern(info);
}

//---------------------------------------------------------------------------

