//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <boost/bind.hpp>
#include <babel.h>
#include <gimite/string.h>
#include "File.h"
#include "FileTestForm.h"
using namespace boost;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmFileTest *frmFileTest;
//---------------------------------------------------------------------------
__fastcall TfrmFileTest::TfrmFileTest(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TfrmFileTest::Test(const std::string& fileName, const std::wstring& wtext,
		TCharCode ccode)
{
	TFileOperationInfo info;
	info.bCheckCharCode_= true;
	CopyFile(fileName.c_str(), (fileName+".bak").c_str(), false);
	file.SetPath(fileName);
	file.SetCharCode(ccode);
	if (file.LoadText(info)!=forOk)
		ShowMessage((fileName+"̃[hɎs").c_str());
	if (wtext!=file.Text())
		ShowMessage((fileName+"烍[heLXgvȂ").c_str());
	if (file.SaveText()!=forOk)
		ShowMessage((fileName+"ւ̃Z[uɎs").c_str());
	string s[2]; char c;
	ifstream fs0(fileName.c_str(), ios::binary);
	while (fs0.get(c)) s[0]+= c;
	ifstream fs1((fileName+".bak").c_str(), ios::binary);
	while (fs1.get(c)) s[1]+= c;
	if (s[0]!=s[1]) ShowMessage((fileName+"ꂽ").c_str());
}

//---------------------------------------------------------------------------
void TfrmFileTest::TestAscii(const std::string& fileName,
	const std::string& text)
{
	TFileOperationInfo info;
	info.bCheckCharCode_= true;
	CopyFile(fileName.c_str(), (fileName+".bak").c_str(), false);
	afile.SetPath(fileName);
	afile.SetCharCode(ccAscii);
	if (afile.LoadText(info)!=forOk)
		ShowMessage((fileName+"̃[hɎs").c_str());
	if (text!=afile.Text())
		ShowMessage((fileName+"烍[heLXgvȂ").c_str());
	if (afile.SaveText()!=forOk)
		ShowMessage((fileName+"ւ̃Z[uɎs").c_str());
	string s[2]; char c;
	ifstream fs0(fileName.c_str(), ios::binary);
	while (fs0.get(c)) s[0]+= c;
	ifstream fs1((fileName+".bak").c_str(), ios::binary);
	while (fs1.get(c)) s[1]+= c;
	if (s[0]!=s[1]) ShowMessage((fileName+"ꂽ").c_str());
}

//---------------------------------------------------------------------------
void TfrmFileTest::SaveText(const std::string& fileName, const std::string& text)
{
	ofstream fs(fileName.c_str(), ios::binary);
	fs << text;
}

//---------------------------------------------------------------------------
void TfrmFileTest::SaveText(const std::string& fileName, const std::wstring& wtext)
{
	ofstream fs(fileName.c_str(), ios::binary);
	fs.write((const char*)wtext.c_str(), wtext.length()*2);
}

//---------------------------------------------------------------------------
void __fastcall TfrmFileTest::Button1Click(TObject *Sender)
{
 	babel::init_babel();
	TFileOperationInfo info;
  TCharCode ccodes[]= {ccSjis, ccEuc, ccUtf16};
  file.SetCharCode(ccodes[ListBox1->ItemIndex]);
  file.SetPath(Edit1->Text.c_str());
  TFileOperationResult r= file.LoadText(info);
  if (r!=forOk) ShowMessage(IntToStr(r));
  Memo1->Lines->Text= babel::unicode_to_sjis(file.Text()).c_str();
	file.SetPath("out.txt");
  file.SaveText(info);
}
//---------------------------------------------------------------------------
void __fastcall TfrmFileTest::Button2Click(TObject *Sender)
{
	bStop_= false;
	Memo1->Lines->Clear();
	ForEachSubDir(Edit1->Text.c_str(), bind(&TfrmFileTest::AddPath, this, _1));
}
//---------------------------------------------------------------------------

void __fastcall TfrmFileTest::Button4Click(TObject *Sender)
{
	bStop_= true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmFileTest::Button3Click(TObject *Sender)
{
	bStop_= false;
	Memo1->Lines->Clear();
	ForEachFileInDir(Edit1->Text.c_str(), "*.cpp", bind(&TfrmFileTest::AddPath, this, _1));
}
//---------------------------------------------------------------------------

void __fastcall TfrmFileTest::btnTestClick(TObject *Sender)
{
	babel::init_babel();
	TStrings* list= Memo1->Lines;
	for (int i= 0; i<(list->Count); ++i){
		if (list->Strings[i]=="") continue;
		ifstream fs(list->Strings[i].c_str(), ios::binary);
		string s[3];
		getline(fs, s[1], '\0');
		s[0]= str_replace(s[1], "\r\n", "\n");
		s[2]= str_replace(s[1], "\r\n", "\r");
		wstring wtext= babel::sjis_to_unicode(s[0]);
		for (int j= 0; j<3; ++j){
			string head= "Test\\"+to_str(j)+"_";
			SaveText(head+"s.txt", s[j]);
			Test2(head+"s.txt", wtext, ccSjis);
			TestAscii(head+"s.txt", s[0]);
			SaveText(head+"e.txt", babel::sjis_to_euc(s[j]));
			Test2(head+"e.txt", wtext, ccEuc);
			SaveText(head+"u16.txt", L"\xfeff"+babel::sjis_to_unicode(s[j]));
			Test2(head+"u16.txt", wtext, ccUtf16);
			SaveText(head+"u8.txt", "\xef\xbb\xbf"+babel::sjis_to_utf8(s[j]));
			Test2(head+"u8.txt", wtext, ccUtf8);
			SaveText(head+"u8n.txt", babel::sjis_to_utf8(s[j]));
			Test2(head+"u8n.txt", wtext, ccUtf8N);
			SaveText(head+"j.txt", babel::sjis_to_jis(s[j]));
			Test2(head+"j.txt", wtext, ccJis);
		}
	}
	ShowMessage("eXgI");
}
//---------------------------------------------------------------------------


