//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <sstream>
#include <boost/bind.hpp>
//#include <gimite/string.h>
#include <gimite/arg_parser.h>
#include <gimite/reg_manager.h>
#include <HtmlHelp.h>
#include <ShellAPI.h>
#include "VCLCommon.h"
#include "Win32Common.h"
#include "Definitions.h"
#include "ResultForm.h"
#include "OptionForm.h"
#include "ProcessForm.h"
#include "ViewForm.h"
#include "AboutForm.h"
#include "MainForm.h"
#include "CopyResultForm.h"
#include "FileErrorDialogForm.h"
#include "Internationalization.h"
#include "DeleteBackupDialogForm.h"
#include "MultiLineEditForm.h"
using namespace std;
using namespace gimite;
using namespace boost::posix_time;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;
extern TAntiDouble adouble;//dNh~
//---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner)
		: TForm(Owner), state_(vsNone), app_(new TDevasApp),
		serial_(new TSerializer)
{
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::WndProc(TMessage &Message)
{
	if (Message.Msg==adouble.Message()){//dN
		WindowState= wsNormal;
		SetForegroundWindow(Handle);
	}
	TForm::WndProc(Message);
}

//---------------------------------------------------------------------------
void TfrmMain::SetGUITexts()//GUĨeLXgݒ
{
	Caption= texts[tiMainFormCaption];
	mniTool->Caption= texts[tiMainMenuTool];
	mniOption->Caption= texts[tiMainMenuOption];
	mniCopyResult->Caption= texts[tiMainMenuCopyResult];
	mniHelp->Caption= texts[tiMainMenuHelp];
	mniHelpC->Caption= texts[tiMainMenuHelpContents];
	mniAbout->Caption= texts[tiMainMenuAbout];
	lblPath->Caption= texts[tiMainTargetFileDir];
	lblFilter->Caption= texts[tiMainTargetFilter];
	lblSearched->Caption= texts[tiMainSearchedStr];
	cmbMode->Items->Strings[smNormal]= texts[tiMainNormalSearch];
	cmbMode->Items->Strings[smWord]= texts[tiMainWordSearch];
	cmbMode->Items->Strings[smRegex]= texts[tiMainRegexSearch];
	chkSubDir->Caption= texts[tiMainSearchSubDir];
	btnOption->Caption= texts[tiMainOption];
	btnSearch->Caption= texts[tiMainSearch];
	mniDirRef->Caption= texts[tiMainPathRefDir];
	mniFileRef->Caption= texts[tiMainPathRefFile];
}

//---------------------------------------------------------------------------
void TfrmMain::ReadCommandLine()//R}hCǂݍ
{
	TStringVector args;
	for (int i= 1; i<=ParamCount(); ++i)
		args.push_back(ParamStr(i).c_str());
	arg_parser ap(args, "fmsK");
	if (ap.normal_argc())
		cmbPath->Text= DetokenizePath(ap.normal_args());

	if (ap.has_option('s'))
		cmbSearched->Text= ap.option_arg('s').c_str();
	if (ap.has_option('f'))
		cmbFilter->Text= ap.option_arg('f').c_str();
	if (ap.has_option('r'))
		chkSubDir->Checked= true;
	if (ap.has_option('R'))
		chkSubDir->Checked= false;

	string sMode= ap.option_arg('m');
	if (sMode=="n")
		cmbMode->ItemIndex= smNormal;
	else if (sMode=="w")
		cmbMode->ItemIndex= smWord;
	else if (sMode=="r")
		cmbMode->ItemIndex= smRegex;

	TOption* opt= app_->Option();
	if (ap.has_option('l'))
		opt->SetByLine(true);
	if (ap.has_option('L'))
		opt->SetByLine(false);
	if (ap.has_option('i'))
		opt->SetCaseSensitive(false);
	if (ap.has_option('I'))
		opt->SetCaseSensitive(true);
	if (ap.has_option('e'))
		opt->SetEscape(true);
	if (ap.has_option('E'))
		opt->SetEscape(false);
	if (ap.has_option('c'))
		opt->SetCheckCharCode(true);
	if (ap.has_option('C'))
		opt->SetCheckCharCode(false);
	if (ap.has_option('b'))
		opt->SetBackup(true);
	if (ap.has_option('B'))
		opt->SetBackup(false);

	string sCode= ap.option_arg('K');
	if (sCode=="a")
		opt->SetCharCode(ccAuto);
	else if (sCode=="s")
		opt->SetCharCode(ccSjis);
	else if (sCode=="w")
		opt->SetCharCode(ccUtf16);
	else if (sCode=="n")
		opt->SetCharCode(ccAscii);
	else if (sCode=="e")
		opt->SetCharCode(ccEuc);
	else if (sCode=="j")
		opt->SetCharCode(ccJis);
	else if (sCode=="u")
		opt->SetCharCode(ccUtf8);
	else if (sCode=="un")
		opt->SetCharCode(ccUtf8N);
    
  if (ap.has_option('n'))
    tmrSearch->Enabled= true;//Ɍ
}

//---------------------------------------------------------------------------
TfrmMain::TStringVector TfrmMain::TokenizePath(const AnsiString& asPaths)
  //擪̃pXNI[gĂΕA
  //łȂΑŜ1̃pXƂ݂Ȃ
{
	if (asPaths==""){
		return TStringVector();
	}else if (asPaths[1]=='\"'){
    return Tokenize(asPaths.c_str());
  }else{
  	return TStringVector(1, asPaths.c_str());
  }
}

//---------------------------------------------------------------------------
TfrmMain::TStringVector TfrmMain::TokenizeFilter(const AnsiString& as)
  //tB^𕪉
{
  TStringVector ss= Tokenize(as.c_str());
	if (ss.empty()) ss.push_back("*");
  return ss;
}

//---------------------------------------------------------------------------
AnsiString TfrmMain::DetokenizePath(const TStringVector& paths)
  //pX̔zNI[gČq
{
	AnsiString as;
  for (size_t i= 0; i<paths.size(); ++i){
  	if (i>0) as+= " ";
  	as+= AnsiString("\"")+paths[i].c_str()+"\"";
  }
  return as;
}

//---------------------------------------------------------------------------
void TfrmMain::SetBaseDir(const TStringVector paths)//tH_ݒ
{
	if (paths.empty()){
		pathBaseDir_= "";
	}else if (GetPathKind(paths[0])==pkDir){
		pathBaseDir_= paths[0];
	}else{
		pathBaseDir_= IncludingDir(paths);//St@C܂ރtH_
  }
}

//---------------------------------------------------------------------------
void TfrmMain::OnPlaceAdd(TAbstractPlace* place)
  //ʒuǉꂽ
{
	GIMITE_MAPROFILED("TfrmMain::OnPlaceAdd");
	frmResult->OnPlacesUpdate(true);
  frmProcess->ThrowIfStopped();
}

//---------------------------------------------------------------------------
void TfrmMain::OnReportProcess(TProcessType type, const std::string& path,
    int nCurrent, int ctAll)
  //ߒ̕
{
	GIMITE_MAPROFILED("TfrmMain::OnReportProcess");
	AnsiString sMsg;
	switch (type){
		case ptEnumFiles: sMsg= "t@CXgAbv..."; break;
		case ptBackup: sMsg= "obNAbv..."; break;
		case ptSearch: sMsg= "..."; break;
		case ptReplace: sMsg= "u..."; break;
		default: assert(false);
	}
	frmProcess->ShowMessage(sMsg, RelativePath(path).c_str(), nCurrent, ctAll);
  frmProcess->ThrowIfStopped();
}

//---------------------------------------------------------------------------
TDecision TfrmMain::OnFileError(const std::string& path,
		TFileOperationResult r)
	//t@CG[[Uɐu
{
	GIMITE_MAPROFILED("TfrmMain::OnFileError");
  string sMsg;
  bool bForceEnabled= true;
  if (resultsSkip_.count(r)) return dcSkip;
  if (r==forError){
    if (state_==vsReplacing)
      sMsg= "ȉ̃t@Cɏ߂܂B\n"
        "t@CǎpɂȂĂ悤łB";
    else
      sMsg= "ȉ̃t@CJ܂B";
    bForceEnabled= false;
  }else if (r==forCharCodeMismatch){
    switch (app_->Option()->CharCode()){
      case ccAuto:
        sMsg= "ȉ̃t@C̕R[h̔Ɏs܂B\n";
        break;
      case ccSjis:
        sMsg= "ȉ̃t@ĆAR[h"
          "IvVƈvĂȂAȕ܂ł܂B\n"
          "IvVŕR[h"
          "ASCIIɐݒ肷΁At@C󂳂ɒuł܂B\n";
          break;
      default:
        sMsg= "ȉ̃t@ĆAR[h"
          "IvVƈvĂȂAȕ܂ł܂B\n"
          "񂪔ppL݂̂̏ꍇ́AIvVŕR[h"
          "ASCIIɐݒ肷΁At@C󂳂ɒuł܂B\n";
          break;
    }
    sMsg+= "usƁÃt@C͑S̓Iɉ܂B";
  }else if (r==forBinary){
    sMsg= "ȉ̃t@C̓oCit@Ĉ悤łB\n"
      "usƁÃt@C͑S̓Iɉ܂B";
  }else if (r==forChanged){
    sMsg= "ȉ̃t@C͌ɕύX܂B\n"
      "1xȂĂuȂƁAt@C܂B";
  }else{
    assert(false);
  }
  TModalResult mr= TfrmFileErrorDialog::ShowMessage(
    sMsg+"\ñt@CXLbv܂H\n\n"+path, bForceEnabled);
  switch (mr){
    case mrNo: return dcForce;
    case mrYes: return dcSkip;
    case mrAbort: return dcAbort;
    case mrRetry: return dcRetry;
    case mrYesToAll:
      resultsSkip_.insert(r);
      return dcSkip;
    default: assert(false); return dcAbort;
  }
}

//---------------------------------------------------------------------------
bool TfrmMain::OnQueryDeleteBackup(const std::vector<TBackupUnit*>& punits)
	//obNAbvu
{
	return TfrmDeleteBackupDialog::ShowMessage(punits)==mrYes;
}

//---------------------------------------------------------------------------
bool TfrmMain::OnBackupExceedingUnit(DWORD size)
	//P̂ŏ𒴂TCỸobNAbvPʂobNAbv邩
{
	return Application->MessageBox((
		"ut@C̍v"+BytesToStr(size)+"܂B\n"
		"obNAbv܂H").c_str(),
		"Devas", MB_ICONINFORMATION|MB_YESNO)==IDYES;
}

//---------------------------------------------------------------------------
void TfrmMain::PlaceForms()//tH[̔zu
{
	int htScreen= GetSystemMetrics(SM_CYMAXIMIZED)
		-2*GetSystemMetrics(SM_CYFRAME);//XN[̃^XNo[
	if (htScreen<frmMain->Height+frmResult->Height){
		frmMain->Top= 0;
		frmResult->Top= htScreen-frmResult->Height;
	}else{
		frmMain->Top= (htScreen-frmMain->Height-frmResult->Height)/2;
		frmResult->Top= frmMain->Top+frmMain->Height;
	}
	frmMain->Left= (Screen->Width-frmMain->Width)/2;
	frmResult->Left= (Screen->Width-frmResult->Width)/2;
	frmView->Left= 0;
	frmView->Top= 0;
	frmView->Width= Screen->Width;
	frmView->Height= frmMain->Top+frmMain->Height;
}

//---------------------------------------------------------------------------
bool TfrmMain::CheckPaths(const TStringVector& paths)
	//ΏۃpX̐`FbN
{
	string s;
	if (paths.size()==0){
		s= "Ώۃt@C/tH_w肳Ă܂B";
	}else if (paths.size()>=2){
		for (size_t i= 0; i<paths.size(); ++i){
			if (GetPathKind(paths[i])==pkDir){
				s= "ΏۂɃtH_w肷鎞́A"
					"tH_1w肵ĂB";
				break;
			}
		}
	}
	if (!s.empty())
		Application->MessageBox(s.c_str(), "Devas", MB_ICONERROR);
	return s.empty();
}

//---------------------------------------------------------------------------
void TfrmMain::Initialize()//r[̏
{
	PlaceForms();

	pathSaved_= ExtractFilePath(Application->ExeName)+"Devas.gts";
	GIMITE_MAPROF_BEGIN_OP("TfrmMain::Initialize#Load");
	serial_->LoadFromFile(pathSaved_.c_str());
	GIMITE_MAPROF_END_OP("TfrmMain::Initialize#Load");

	app_->SetOnPlaceAdd(bind(&TfrmMain::OnPlaceAdd, this, _1));
	app_->SetOnReportProcess(bind(&TfrmMain::OnReportProcess, this,
		_1, _2, _3, _4));
	app_->SetOnFileError(bind(&TfrmMain::OnFileError, this, _1, _2));
	app_->SetOnQueryDeleteBackup(
		bind(&TfrmMain::OnQueryDeleteBackup, this, _1));
	app_->SetOnBackupExceedingUnit(
		bind(&TfrmMain::OnBackupExceedingUnit, this, _1));

	if (cmbFilter->Items->Count==0){
		cmbFilter->Items->Add("*.txt *.htm *.html");
		cmbFilter->Items->Add("*.c *.cpp *.h");
	}
	if (cmbPath->Items->Count>0) cmbPath->ItemIndex= 0;
	if (cmbFilter->Items->Count>0) cmbFilter->ItemIndex= 0;
  cmbSearched->Text= EscapeMultiLine(
      Clipboard()->AsText.SubString(1, lenInitialSearch_).c_str()).c_str();
    //񗓂Nbv{[h̓eŏ

	ReadCommandLine();

	if (serial_->Ver3First()){//Ver.3.0ȍ~̏߂Ă̋N
		if (FileExists(ExtractFilePath(Application->ExeName)+"Devas.gbi"))
			Application->MessageBox(
				"Ver.3.0ݒt@Č`ς߁AIvVƗ"
				"܂B", "Devas", MB_ICONINFORMATION);
		serial_->SetVer3First(false);
	}
}

//---------------------------------------------------------------------------
void TfrmMain::Settle()//r[̌n
{
	GIMITE_MAPROF_BEGIN_OP("TfrmMain::Settle#Save");
	serial_->SaveToFile(pathSaved_.c_str());
	GIMITE_MAPROF_END_OP("TfrmMain::Settle#Save");
}

//---------------------------------------------------------------------------
std::string TfrmMain::RelativePath(const std::string path)
  //pathtH_̑΃pX߂
{
	return ::RelativePath(path, pathBaseDir_);
}

//---------------------------------------------------------------------------
void TfrmMain::SetState(TViewState state)//Ԃ̕ύX
{
	state_= state;

	stbMain->Panels->Items[0]->Text= "";
	frmResult->stbMain->Panels->Items[0]->Text= "";
	if (frmView->Visible && state_!=vsReplacable && state_!=vsUnreplacable)
		frmView->ForceToClose();
	if (state_==vsSearching || state_==vsReady){
		app_->ClearPlaceList();
		frmResult->OnPlacesUpdate(false);
	}
	bool bSearchable=
		state_==vsReady || state_==vsReplacable || state_==vsUnreplacable;
	btnSearch->Enabled= bSearchable;
	cmbPath->Enabled= bSearchable;
	btnPathRef->Enabled= bSearchable;
	cmbFilter->Enabled= bSearchable;
	cmbSearched->Enabled= bSearchable;
	cmbMode->Enabled= bSearchable;
	chkSubDir->Enabled= bSearchable;
	mniOption->Enabled= bSearchable;
	btnOption->Enabled= bSearchable;
	mniCopyResult->Enabled= state_==vsReplacable || state_==vsUnreplacable;
	frmResult->btnReplace->Enabled= state_==vsReplacable;
	frmResult->btnConfirm->Enabled= state_==vsReplacable;
	if (state_==vsReady && !frmMain->Active)
			//frmMaincmbSearchedȊO̗ɓ͂n߂vsReadyɕω
			//ꍇɂ́AtH[JXύXĂ͑ʖځB
		cmbSearched->SetFocus();
	else if (state_==vsReplacable)
		frmResult->cmbReplacing->SetFocus();
	frmResult->Visible= state_==vsSearching || state_==vsReplacable
		|| state_==vsUnreplacable || state_==vsReplacing;
	frmProcess->Visible= state_==vsSearching || state_==vsReplacing;
	if (state_==vsSearching || state_==vsReplacing)
  	Screen->Cursor= crAppStart;
  else
  	Screen->Cursor= crDefault;
}

//---------------------------------------------------------------------------
void TfrmMain::ComboBoxAddToHistory(TComboBox* cmb)
	//R{{bNXcmbTextɒǉ
{
  //eLXg̉sB
  reg_manager rm;
  cmb->Text= rm.substitute(cmb->Text.c_str(), "[\r\n]", "", "g").c_str();

  //ɒǉB
	int i;
	AnsiString s= cmb->Text;
	for (i= 0;i<cmb->Items->Count;++i){
		if (cmb->Items->Strings[i]==s) break;//v
	}
	if (i<cmb->Items->Count){//vڗL
		cmb->Items->Delete(i);
	}else if (cmb->Items->Count>ctComboBoxHistory_-1){//vڂȂAK萔
		cmb->Items->Delete(cmb->Items->Count-1);//̍ڂ폜
	}
	cmb->Items->Insert(0,s);
	cmb->ItemIndex= 0;
}

//---------------------------------------------------------------------------
void TfrmMain::ClearSkips()
	///úuSăXLbvv̏ԂNA
{
  resultsSkip_.clear();
}

//---------------------------------------------------------------------------
void TfrmMain::OutputMessage(const std::string& s)
  //Xe[^Xo[ɃbZ[W\
{
  TStatusPanel* panel= frmResult->Visible ?
    frmResult->stbMain->Panels->Items[0] : stbMain->Panels->Items[0];
  panel->Text= s.c_str();
}

//---------------------------------------------------------------------------
void TfrmMain::OnOptionChanged()//IvVXVꂽ
{
	if (state_!=vsReady) SetState(vsReady);
	cmbMode->ItemIndex= int(app_->Option()->Mode());
  chkSubDir->Checked= app_->Option()->SubDir();
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::WMDropFiles(TWMDropFiles &msg)
{
	//GNXv[tH[ւ̃hbOhbvɑΉB
	int n= DragQueryFile((HDROP)msg.Drop, -1, NULL, MAX_PATH);
	char path[MAX_PATH];
	TStringVector paths;
	for(int i=0; i<n; i++){
		DragQueryFile((HDROP)msg.Drop, i, path, MAX_PATH);
		paths.push_back(path);
	}
  cmbPath->Text= DetokenizePath(paths);
	DragFinish((HDROP)msg.Drop);
}

//---------------------------------------------------------------------------
void __fastcall TfrmMain::FormCreate(TObject *Sender)
{
	SetGUITexts();
	DragAcceptFiles(Handle, true);
//	Application->OnRestore= AppRestore;
//	Application->OnException= ComOnException;//O蓖
}
//---------------------------------------------------------------------------
void __fastcall TfrmMain::btnSearchClick(TObject *Sender)
{
  if (state_==vsReady || state_==vsReplacable || state_==vsUnreplacable){

		TStringVector paths= TokenizePath(cmbPath->Text);
		if (!CheckPaths(paths)) return;

		app_->Option()->SetMode(TSearchMode(cmbMode->ItemIndex));
		app_->Option()->SetSubDir(chkSubDir->Checked);

		ComboBoxAddToHistory(cmbPath);
		ComboBoxAddToHistory(cmbFilter);
		ComboBoxAddToHistory(cmbSearched);

		SetState(vsSearching);

		if (app_->Option()->Mode()==smRegex)
			frmResult->cmbReplacing->Text= "";
		else
			frmResult->cmbReplacing->Text= cmbSearched->Text;

		SetBaseDir(paths);
		ClearSkips();

		TSearchResult r= srError;
		string sException;
		try{
			r= app_->Search(paths,
				TokenizeFilter(cmbFilter->Text), cmbSearched->Text.c_str());
		}catch (exception& e){
			sException= e.what();
		}

		if (r==srError || r==srInvalid || r==srNoFiles || !app_->PlaceList()
				|| app_->PlaceList()->PlaceCount()==0){
			SetState(vsReady);
			if (r==srStopped){
	      OutputMessage("𒆎~܂B");
      }else{
				string sMsg;
				switch (r){
					case srInvalid: sMsg= "񂪕słB"; break;
					case srNoFiles: sMsg= "Ώۃt@C܂B"; break;
					case srError: sMsg= "G[܂B\n"+sException; break;
					default: sMsg= "܂I"; break;
				}
				Application->MessageBox(sMsg.c_str(), "Devas");
			}
		}else{
    	SetState(vsReplacable);
    	OutputMessage(
        r==srStopped ? "𒆎~܂B" : "܂B");
    }
    
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormShow(TObject *Sender)
{
	OnOptionChanged(); //ԂvsReady
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::ctlSearchChange(TObject *Sender)
	//̕ύX
{
	if (state_==vsReplacable || state_==vsUnreplacable)
  	SetState(vsReady);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniOptionClick(TObject *Sender)
{
	if (state_==vsReady || state_==vsReplacable || state_==vsUnreplacable){
  	if (frmOption->ShowModal()==mrOk){
      OnOptionChanged();
    }
  }
}
//---------------------------------------------------------------------------


void __fastcall TfrmMain::btnPathRefClick(TObject *Sender)
{
	TPoint p= ClientToScreen(Point(btnPathRef->Left,
  	btnPathRef->Top+btnPathRef->Height));
	pmnPathRef->Popup(p.x,p.y);//ReLXgj[̕\
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniDirRefClick(TObject *Sender)
{
	TStringVector paths= TokenizePath(cmbPath->Text);
  AnsiString as;
  if (!paths.empty()) as= paths[0].c_str();
  AnsiString pathR= SelectDir(Handle, "ΏۃtH_̑I", as);
  if (pathR!=""){
  	cmbPath->Text= pathR;
    ctlSearchChange(NULL);//ς
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniFileRefClick(TObject *Sender)
{
	TStringVector paths= TokenizePath(cmbPath->Text);
  if (!paths.empty()){
    if (GetPathKind(paths[0])==pkDir)
		  dlgOpen->InitialDir= paths[0].c_str();
    else
	  	dlgOpen->FileName= paths[0].c_str();
  }
  if (dlgOpen->Execute()){
  	TStringVector paths;
    for (int i= 0; i<dlgOpen->Files->Count; ++i)
    	paths.push_back(dlgOpen->Files->Strings[i].c_str());
    cmbPath->Text= DetokenizePath(paths);
    ctlSearchChange(NULL);//ς
  }
}
//---------------------------------------------------------------------------



void __fastcall TfrmMain::mniHelpCClick(TObject *Sender)
{
	Screen->Cursor= crHourGlass;//v
	ShowHtmlHelp(ExtractFilePath(Application->ExeName)+"Devas.chm");
	Screen->Cursor= crDefault;//v߂
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniAboutClick(TObject *Sender)
{
	frmAbout->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	if (state_==vsReady || state_==vsReplacable || state_==vsUnreplacable)
		SetState(vsReady);//r[̕ۑ_CAO\Ȃǂ̂
	else
    CanClose= false;
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::evtAppException(TObject *Sender, Exception *E)
{
	Application->MessageBox(("\ȂG[܂B\n"+E->Message
		+"\nG[̏󋵂Ə̃bZ[WA"
		"<gimite@mx12.freecom.ne.jp>ɋĂ"
		"܂B").c_str(), "Devas", MB_ICONERROR);
	exit(EXIT_FAILURE);//I
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::mniCopyResultClick(TObject *Sender)
{
	frmCopyResult->ShowModal();	
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::tmrSearchTimer(TObject *Sender)
{
  tmrSearch->Enabled= false;
  btnSearchClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TfrmMain::btnSearchedEditClick(TObject *Sender)
{
  string before= cmbSearched->Text.c_str();
  string after= TfrmMultiLineEdit::EditEscapedText(
    "̕ҏW", before);
  if (before!=after){
    cmbSearched->Text= after.c_str();
    ctlSearchChange(NULL);
  }
}
//---------------------------------------------------------------------------

