//---------------------------------------------------------------------------
#ifndef PlaceListH
#define PlaceListH
//---------------------------------------------------------------------------
#include <deque>
#include <boost/shared_ptr.hpp>
#include <boost/function.hpp>
#include "Place.h"
//---------------------------------------------------------------------------
//ʒuXg̋ʊNX
class TAbstractPlaceList
{
public:
	typedef boost::function1<void, TAbstractPlace*> TOnPlaceAdd;

	virtual ~TAbstractPlaceList(){}
	virtual TAbstractPlace* Place(int n)const= 0;//nԖڂ̈ʒu
	virtual int PlaceCount()const= 0;//ʒu̐
  void SetOnPlaceAdd(TOnPlaceAdd func){onPlaceAdd_= func;}

protected:
  TOnPlaceAdd OnPlaceAdd()const{return onPlaceAdd_;}

private:
	TOnPlaceAdd onPlaceAdd_;//ʒuǉꂽ

};

//---------------------------------------------------------------------------
//ʒuXg
template <class TChar>
class TPlaceList: public TAbstractPlaceList
{
	typedef boost::shared_ptr<TPlace<TChar> > TPlacePtr;
	typedef std::deque<TPlacePtr> TPlaces;

public:
	typedef std::basic_string<TChar> TString;
	typedef std::vector<typename TString::size_type> TSizes;
	typedef std::vector<TString> TReferenceStrings;

	virtual TPlace<TChar>* Place(int n)const{return places_[n].get();}
  	//nԖڂ̈ʒu
	virtual int PlaceCount()const{return places_.size();}//ʒu̐
  void Add(const std::string& path, int nLine, const TString& text, int pos,
  		int len, const TReferenceStrings& tssRef, const TSizes& posesReturn);
  	//pathnLinesڂtextposlenʒuɒǉ
  void Erase(int n){places_.erase(places_.begin()+n);}
  	//nԖڂ̈ʒu폜

private:
	TPlaces places_;//ʒu

};

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//ev[g֐̎
//---------------------------------------------------------------------------
template <class T>
void TPlaceList<T>::Add(const std::string& path, int nLine, const TString& text,
		int pos, int len, const TReferenceStrings& tssRef,
    const TSizes& posesReturn)
  //pathnLinesڂtextposlenʒuɒǉ
{
  places_.push_back(TPlacePtr(
  	new TPlace<T>(path, nLine, text, pos, len, tssRef, posesReturn)));
  if (!OnPlaceAdd().empty()) OnPlaceAdd()(places_.back().get());
}

//---------------------------------------------------------------------------
#endif
