//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop
#include <memory>
#include <babel.h>
#include "Win32Common.h"
#include "Exceptions.h"
#include "SearchedPattern.h"
using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TAbstractSearchedPattern*
    TAbstractSearchedPattern::NewSearchedPattern(const TSearchInfo& info)
  //w̏𖞂p^[
{
	babel::init_babel();
	auto_ptr<TAbstractSearchedPattern> sp;
	wstring wsSearched;
  string sSearched;
  if (info.bMultiByte_){
  	wsSearched= babel::sjis_to_unicode(info.sSearched_);
    if (info.mode_!=smRegex && info.bEscape_)
    	wsSearched= Unescape(wsSearched);
  }else{
  	sSearched= info.sSearched_;
    if (info.mode_!=smRegex && info.bEscape_)
    	sSearched= Unescape(sSearched);
  }

  if (info.mode_!=smNormal || !info.bCaseSensitive_){
    boost::regbase::flag_type flag= boost::regbase::normal;
    if (!info.bCaseSensitive_) flag|= boost::regbase::icase;
  	if (info.bMultiByte_){
    	wstring wsRegex;
      if (info.mode_==smRegex) wsRegex= wsSearched;
      else if (info.mode_==smWord) wsRegex= MakeWordRegex(wsSearched);
      else wsRegex= EscapeForRegex(wsSearched);
      sp.reset(new TRegexSearchedPattern<wchar_t>(wsRegex, flag, info.bByLine_,
      	info.bRecordLine_));
    }else{
    	string sRegex;
      if (info.mode_==smRegex) sRegex= sSearched;
      else if (info.mode_==smWord) sRegex= MakeWordRegex(sSearched);
      else sRegex= EscapeForRegex(sSearched);
      sp.reset(new TRegexSearchedPattern<char>(sRegex, flag,
      	info.bByLine_, info.bRecordLine_));
    }
  }else{//smNormal & bCaseSensitive
    if (info.bMultiByte_)
      sp.reset(new TNormalSearchedPattern<wchar_t>(wsSearched,
      	info.bByLine_, info.bRecordLine_));
    else
      sp.reset(new TNormalSearchedPattern<char>(sSearched,
      	info.bByLine_, info.bRecordLine_));
  }
  assert(sp.get());
  if (sp->Valid()) return sp.release();
  else throw EInvalidSearchedPattern();//sȌp^[
}

//---------------------------------------------------------------------------
