//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <algorithm>
#include <gimite/string_algo.h>
#include <boost/cast.hpp>
#include "Win32Common.h"
#include "MainForm.h"
#include "ViewForm.h"
using namespace std;
using namespace gimite;
using namespace boost;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "SonEdit"
#pragma resource "*.dfm"
TfrmView *frmView;
//---------------------------------------------------------------------------
__fastcall TfrmView::TfrmView(TComponent* Owner)
		: TForm(Owner), bRefresh(false)
{
}
//---------------------------------------------------------------------------
void TfrmView::LoadFromFile(const std::string& path)//t@C烍[h
{
  const TFileSet* setFile= frmMain->DevasApp()->FileSet();
  assert(setFile);
  if (setFile->MultiByte()){
  	fileMB_.reset(setFile->NewFile(path, (wchar_t*)0));
		if (fileMB_->LoadText()==forError)
			throw EFOpenError("");
	}else{
		fileSB_.reset(setFile->NewFile(path, (char*)0));
		if (fileSB_->LoadText()==forError)
			throw EFOpenError("");
	}
}

//---------------------------------------------------------------------------
void TfrmView::ShowText()//[heLXg\
{
	if (fileMB_.get()){
		wstring ws= fileMB_->Text();
		replace(ws.begin(), ws.end(), L'\r', L' ');//*1
		sedFile->Text= ToSjis(
      str_replace_all_copy<wchar_t>(ws, L"\n", L"\r\n")).c_str();
	}else if (fileSB_.get()){
		string s= fileSB_->Text();
		replace(s.begin(), s.end(), '\r', ' ');//*1
		sedFile->Text= str_replace_all_copy<char>(s, "\n", "\r\n").c_str();
	}else{
		sedFile->Text= "";
	}
}

//*1	sR[h݂Ăt@C̏ꍇA\rcĂTSonEdiť듮
//		NB
//---------------------------------------------------------------------------
void TfrmView::GetAnsiPosition(const TAbstractPlace* place,
    int& nLine, int& pos, int& len)
  //ẅʒuAnsiStringł̏ꏊ߂
{
  if (fileMB_.get())
    GetAnsiPosition(polymorphic_downcast<const TPlace<wchar_t>*>(place),
    	fileMB_->Text(), nLine, pos, len);
  else if (fileSB_.get())
    GetAnsiPosition(polymorphic_downcast<const TPlace<char>*>(place),
    	fileSB_->Text(), nLine, pos, len);
  else
  	assert(false);
}

//---------------------------------------------------------------------------
void TfrmView::SaveToFile()//t@Cɕۑ
{
	if (fileMB_.get()){
  	babel::init_babel();
  	wstring& ws= fileMB_->Text();
    ws= babel::sjis_to_unicode(sedFile->Text.c_str());
    ws.erase(remove(ws.begin(), ws.end(), uchar('\r')), ws.end());//\r
		if (fileMB_->SaveText()==forError)
			throw EFOpenError("");
		}else if (fileSB_.get()){
		string& s= fileSB_->Text();
		s= sedFile->Text.c_str();
		s.erase(remove(s.begin(), s.end(), '\r'), s.end());//\r
		if (fileSB_->SaveText()==forError)
			throw EFOpenError("");
	}
}

//---------------------------------------------------------------------------
void TfrmView::ShowPlace(int nPlace)
	//(ԍ)t@CI[vĔʒu
{
	const TAbstractPlaceList* list= frmMain->DevasApp()->PlaceList();
  if (!list) return;
	Screen->Cursor= crHourGlass;//v
	Show();

	//ʒu擾
  const TAbstractPlace* place= list->Place(nPlace);
	string pathN= place->Path();

	bool bLoad= bRefresh || path!=pathN;//[hKv
	if (bLoad){
		if (path!="") Save(true, false);
		path= pathN;
		Caption= ("Devas - "+frmMain->RelativePath(path)).c_str();
	}
	int nLine,pos,len;
  if (bLoad){
    try{
      LoadFromFile(path);
      ShowText();
    }catch(Exception& e){
      Application->MessageBox(
      	("ȉ̃t@C̓ǂݍݒɃG[܂B\n\n"
        +AnsiString(path.c_str())+"\n\n"+e.Message).c_str(), "Devas",
        MB_ICONERROR);
      bChanged= false;
      Close();
      return;
    }
  }
  GetAnsiPosition(place, nLine, pos, len);
	if (bLoad){
		bChanged= false;//Loaď̕Kv
		sedFile->ClearUndoRecord();
	}

  //Iʒu̐K
	if (sedFile->Lines->Count==0){
  	pos= nLine= 0;
  }else{
		if (nLine>=sedFile->Lines->Count){
			nLine= sedFile->Lines->Count-1;
			pos= strlen(sedFile->Lines->Items[nLine].c_str());
		}else{
			int len= strlen(sedFile->Lines->Items[nLine].c_str());
			if (pos>len) pos= len;
		}
	}
	//ʒuI
	try{
		sedFile->NtoWCurPos(pos, nLine);//[vWɕϊ
		sedFile->CurSet(pos, nLine, SetCenter);
		sedFile->SelLength= len;
		sedFile->RefreshLine();
	}catch (...){}

	bRefresh= false;
	Screen->Cursor= crDefault;//v߂
}

//---------------------------------------------------------------------------
bool TfrmView::Save(bool bChk, bool bCancelable)
	//t@C̕ύX̕ۑiLZfalsej
	//	bChk: ۑ邩mF
	//	bCancelable: LZ\
{
	bool bOk= true;

	if (!bChanged) return true;//ύXĂȂ
	if (bChk){
		string sMsg;
		if (frmMain->State()==vsReplacable){
			sMsg= "\""+frmMain->RelativePath(path)
				+"\"ւ̕ύXۑ܂H\n\n"
				"ۑƁǍ݂ʂ̂܂܎gȂȂ\܂B\n"
				"̂߁A[u]̑Oɂx[]Kv܂B";
		}else{
			sMsg= "\""+frmMain->RelativePath(path)+"\"ւ̕ύXۑ܂H";
		}
		int r= Application->MessageBox(sMsg.c_str(),
			"Devas", (bCancelable? MB_YESNOCANCEL : MB_YESNO)|MB_ICONINFORMATION);
		if (r==IDCANCEL) return false;
		else if (r==IDNO) return true;
	}

	Screen->Cursor= crHourGlass;//v
	while (true){
		try{
			SaveToFile();
		}catch(Exception& e){
			if (Application->MessageBox(
					("t@CۑɃG[܂B\n\n"+e.Message).c_str(),
					"Devas", MB_RETRYCANCEL|MB_ICONERROR)==IDRETRY)
				continue;
			bOk= false;
		}
		break;
	}
	Screen->Cursor= crDefault;//v߂

	if (frmMain->State()==vsReplacable && bOk)
		frmMain->SetState(vsUnreplacable);//u͕s
	if (bOk) bChanged= false;//ύXtONA

	return !bCancelable || bOk;
}

//---------------------------------------------------------------------------
void TfrmView::ForceToClose()//K
{
	Save(true, false);
	bChanged= false;//ۑɎsĂĕۑ͂Ȃ
	Close();
}

//---------------------------------------------------------------------------
void TfrmView::RefreshWrap()//܂Ԃ̗L𔽉f
{
	if (mniWrap->Checked){
		sedFile->AutoWrap= true;
	}else{
		sedFile->AutoWrap= false;
		sedFile->Column= sedFile->MaxCurPosX;
	}
	sedFile->Recreate();
}

//---------------------------------------------------------------------------
void __fastcall TfrmView::sedFile1Change(TObject *Sender)
{
	bChanged= true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::FormCloseQuery(TObject *Sender,
						bool &CanClose)
{
	if (!Save(true, true)){//ۑmF
		CanClose= false;
	}else{
		path= "";
		bChanged= false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniSaveClick(TObject *Sender)
{
	Save(false, true);	
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniCutClick(TObject *Sender)
{
	sedFile->Cut();
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniCopyClick(TObject *Sender)
{
	sedFile->TxtCopy();
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniPasteClick(TObject *Sender)
{
	sedFile->Paste();
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::sedFileSelectionChange(TObject *Sender)
{
	int x, y;
	x= 0; y= sedFile->CurPosY;
	sedFile->WtoNCurPos(x, y);
	stbMain->Panels->Items[0]->Text= IntToStr(y+1)+"s";
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniWrapClick(TObject *Sender)
{
	mniWrap->Checked= !mniWrap->Checked;
	RefreshWrap();
}
//---------------------------------------------------------------------------


void __fastcall TfrmView::mniEditClick(TObject *Sender)
{
	mniUndo->Enabled= sedFile->Modified;
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniUndoClick(TObject *Sender)
{
	if (sedFile->Modified) sedFile->Undo();	
}
//---------------------------------------------------------------------------

void __fastcall TfrmView::mniPopupPopup(TObject *Sender)
{
  mniPopupUndo->Enabled= sedFile->Modified;
}
//---------------------------------------------------------------------------

