//---------------------------------------------------------------------------
/*
                         R}heXg  by Gimite
  
  [Uɂ͂Ƃɑ΂o͂L^A͂ɑ΂ĈȑOƓ
  o͂Ԃ邩Ń`FbNB
  
	int main(int argc, char* argv[])
	{
		command_test ctest(ctm_add, "ctest.log");
		istream& tin= ctest.tin();
		ostream& tout= ctest.tout();
		do{
			ceXg鏈c
		}while (ctest.next());
		return 0;
	}

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_command_testH
#define GIMITE_command_testH
//---------------------------------------------------------------------------
#include <iostream>//cin, cout, cerr, istream, ostream
#include <fstream>//ifstream, ofstream
#include <sstream>//istringstream, ostringstream
#include <exception>//exception
#include <utility>//pair
#include <string>//string, getline
#include <gimite/tree_streambuf.h>
#include <gimite/logged_istream.h>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
enum command_test_mode{
	ctm_input,//̓[h
	ctm_add,//ǉ̓[h
	ctm_test,//eXg[h
	ctm_none,//Ȃ
};

enum command_test_option{
	cto_normal= 0,
	cto_not_repeat= 1,//iǉj̓[hœ͂JԂȂ
	cto_not_ask= 2,//iǉj̓[hŕۑ邩uȂ
	cto_save_if_eof= 4,//EOF͂ꂽۑ
};

//---------------------------------------------------------------------------
//command_testŔO
class command_test_error: public std::exception
{
public:
	command_test_error(const char* msg): msg_(msg){}
	virtual const char* what()const throw(){return msg_.c_str();}
	virtual ~command_test_error() throw(){}

private:
	std::string msg_;

};

//---------------------------------------------------------------------------
//R}heXg
class command_test
{
public:
	command_test(command_test_mode mode, const char* path,
			command_test_option opt= cto_normal)
			: mode_(mode), path_(path), opt_(opt), is_checked_(false),
			is_failed_(false), n_(1),
			lin_(std::cin), loutbuf_(std::cout.rdbuf(), sout_.rdbuf()),
			lout_(&loutbuf_){
		if (mode_==ctm_test){
			ifs_.open(path);
			if (!load_log())
				throw command_test_error("Command test error: Log is empty.");
		}else if (mode_==ctm_input || mode_==ctm_add){
			ofs_.open(path, (mode==ctm_input)? std::ios::out:std::ios::app);
		}
	}
	~command_test(){
		if (mode_==ctm_test) check();
	}
	//cin̑
	std::istream& tin(){
		if (mode_==ctm_test)
			return sin_;
		else if (mode_==ctm_input || mode_==ctm_add)
			return lin_;
		else
			return std::cin;
	}
	//cout̑
	std::ostream& tout(){
		if (mode_==ctm_test)
			return sout_;
		else if (mode_==ctm_input || mode_==ctm_add)
			return lout_;
		else
			return std::cout;
	}
	//̎sJn
	bool next(){
		if (mode_==ctm_test){
			check();
			clear_buffer();
			++n_;
			bool res= load_log();
			if (!res){
				if (!is_failed_)
					std::cerr<<(n_-1)<<" test(s) succeed."<<std::endl;
				is_checked_= true;//fXgN^Ń`FbN̂h
			}
			return res;
		}else if (mode_==ctm_input || mode_==ctm_add){
			if (!lin_.eof()){
				std::pair<bool, bool> res= ask();
				if (res.first) save_log();
				clear_buffer();
				return res.second && !(opt_&cto_not_repeat);
			}else{//͂EOF
				if (opt_&cto_save_if_eof) save_log();
				return false;
			}
		}else{
			return false;
		}
	}
	//킹ieXg[h̍ŌɎsj
	void check(){
		if (mode_!=ctm_test || is_checked_) return;
		std::string cline, aline;
		std::istringstream cis(sout_.str());
		std::istringstream ais(outs_);
		for (int i= 1; ; ++i){
			cline= aline= "(line not exist)";
			std::getline(cis, cline, '\n');
			std::getline(ais, aline, '\n');
			if (!cis && !ais) break;
			if (!cis || !ais || aline!=cline)
				check_error(i, cline, aline);
		}
		is_checked_= true;
	}

private:
	const command_test_mode mode_;//[h
	const std::string path_;//Ot@C̃pX
	const command_test_option opt_;//IvV
	bool is_checked_;//`FbNς݂
	bool is_failed_;//܂łɊԈႢ
	int n_;//eXgԍ
	std::ifstream ifs_;//Ot@C̓
	std::ofstream ofs_;//Ot@Cւ̏o
	std::istringstream sin_;//񂩂̓̓Xg[
	std::ostringstream sout_;//ւ̏o̓Xg[
	logged_istream lin_;//Ocin
	tree_streambuf loutbuf_;//Ocoutpstreambuf
	std::ostream lout_;//Ocout
	std::string outs_;//oׂ͂

	//̃Õ[h
	bool load_log(){
		std::string line;
		std::string ins;
		if (!std::getline(ifs_, line, '\n')) return false;
		if (line!="  -- cin log --") return false;
		while (std::getline(ifs_, line, '\n')){
			if (line=="  -- cout log --") break;
			ins+= line+"\n";
		}
		sin_.str(ins.substr(0, ins.length()-1));//Ō\n
		sin_.clear();
		outs_.clear();
		while (std::getline(ifs_, line, '\n')){
			if (line=="  -- next --") break;
			outs_+= line+"\n";
		}
		outs_.resize(outs_.length()-1);//Ō\n
		return true;
	}
	//OZ[u
	void save_log(){
		ofs_<<"  -- cin log --"<<std::endl;
		ofs_<<lin_.log()<<std::endl;
		ofs_<<"  -- cout log --"<<std::endl;
		ofs_<<sout_.str()<<std::endl;
		ofs_<<"  -- next --"<<std::endl;
	}
	//obt@NA
	void clear_buffer(){
		sout_.str("");
		lin_.clear_log();
		is_checked_= false;
	}
	//ۑ邩[Uɐu
	std::pair<bool, bool> ask(){
		if (opt_&cto_not_ask){
			return std::pair<bool, bool>(true, true);
		}else{
			std::cerr<<"Command test: OK (y/n)? ";
			std::string s;
			std::getline(std::cin, s, '\n');
			return std::pair<bool, bool>
				(!s.empty() && s[0]=='y', s.length()<2 || s[1]!='q');
		}
	}
	//킹ŊԈႢ
	void check_error(int nline, const std::string& cline,
			const std::string& aline){
		std::cerr<<"test "<<n_<<" line "<<nline<<": must be"<<std::endl;
		std::cerr<<aline<<"$"<<std::endl;
		std::cerr<<"but"<<std::endl;
		std::cerr<<cline<<"$"<<std::endl<<std::endl;
		is_failed_= true;
	}

};

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
