/*
  g:
    
    void f(vector<int>& vec)
    {
      foreach (it, vector<int>, vec){
        ++*it;
      }
    }
    
    void g()
    {
      foreach_copy (it, vector<int>, e()){
        cout << *it << endl;
      }
    }
    
    void h(const vector<int>& vec)
    {
      foreach_const_ref (it, vector<int>, vec){
        cout << *it << endl;
      }
    }
    
*/


#ifndef FOREACH_H
#define FOREACH_H


template <class T, class S= T>
struct foreach_wrap_t
{
  foreach_wrap_t(T v): value(v){}
  operator bool()const{ return false; }
  const S value;
};


#define foreach(iter, cont_type, cont) \
  if (foreach_wrap_t<cont_type&> iter##__wrap= (cont)) ; \
  else \
    for (cont_type::iterator iter= iter##__wrap.value.begin(); \
      iter!=iter##__wrap.value.end(); ++iter)

#define foreach_copy(iter, cont_type, cont) \
  if (foreach_wrap_t<const cont_type&, cont_type> iter##__wrap= (cont)) ; \
  else \
    for (cont_type::const_iterator iter= iter##__wrap.value.begin(); \
      iter!=iter##__wrap.value.end(); ++iter)

#define foreach_const_ref(iter, cont_type, cont) \
  if (foreach_wrap_t<const cont_type&> iter##__wrap= (cont)) ; \
  else \
    for (cont_type::const_iterator iter= iter##__wrap.value.begin(); \
      iter!=iter##__wrap.value.end(); ++iter)


#endif
